

;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
setup_sound:
	cly
	ldx	#5*32	;Sine wave
	jsr	setup_sound_regs	;0

	ldy	#1
	ldx	#5*32	;Sine wave
	jsr	setup_sound_regs	;1
	lda	#$80
	sta	$0809			;Turn OFF LFO

	ldy	#2
	ldx	#128	;Triangle
;	ldx	#192	;Triangle
	jsr	setup_sound_regs	;2
	ldy	#3
	clx
	jsr	setup_sound_regs	;3
	ldy	#4
	clx
	jsr	setup_sound_regs	;4
	stz	$0807			;clear noise
	ldy	#5
	clx
	jsr	setup_sound_regs	;5
	stz	$0807			;clear noise



	stz	$0800
	stw	#DEF_FREQ,$0802		;Write default frequency
	lda	#$FF
	sta	$0805				;Equal Balance.
	sta	$0801				;Master Volume
	lda	#$80
	ora	#$1F			;We do this by ORing with the volume.
	sta	$0804

	rts


setup_sound_regs:	;Inputs: Y-channel #, X-waveform

	sty	$0800		;Choose channel 0
	lda	#%01000000	;reset the waveform write pointer
	sta	$0804
	lda	#%00000000
	sta	$0804

	cly
load:   lda     wave_tables,x  ; Load a sample in A
	sta     $0806   ; Write the sample
	inx             ; Increment the table index
	iny
	cpy     #32     ; Have we reached the end?
	bne     load    ; If no continue

	stw	#$0000,$0802		;Write a word (frequency)
	lda	#$00
	sta	$0805				;Equal Balance.
	sta	$0801				;Master Volume
;	lda	#$1F
;	ora	#$80			;We do this by ORing with the volume.
;	sta	$0804



	rts
;-----------------------------------------------
LowPassWaves:
	.incbin "INC\lopass-crush-pce.raw"
HighPassWaves:
	.incbin "INC\hipasslong.bin"

wave_tables:
wave_square0: db 31,31,31,31,0,0,0,0,0,0,0,0,0,0,0,0
	db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
wave_square1: db 30,30,30,30,30,30,30,30,0,0,0,0,0,0,0,0
	db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
wave_square2: db 31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31
	db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
wave_square3: db 30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30
	db 30,30,30,30,30,30,30,30,0,0,0,0,0,0,0,0
wave_triangle: db 0,2,4,6,8,10,12,14,16,18,20,22,24,26,28,30
	db 31,29,27,25,23,21,19,17,15,13,11,9,7,5,3,1
wave_sine:   db      18,22,24,26,28,28,30,30
	db      30,30,28,28,26,24,22,18
	db      12,8,6,4,2,2,0,0
	db      0,0,2,2,4,6,8,12
wave_saw:	db	0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15
	db	16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31
wave_sawinv: db 31,30,29,28,27,26,25,24,23,22,21,20,19,18,17,16
	db 15,14,13,12,11,10,9,8,7,6,5,4,3,2,1,0
wave_silence: db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
wave_silence2: db 30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30
	db 30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30

Wave_Mirror_Table:
	.db 0,1,2,3,4,5,6,7,8,9,10,11,12,13
	.db 14,15,16,17,18,19,20,21,22,23,24
	.db 24,23,22,21,20,19,18,17,16,15,14
	.db 13,12,11,10,9,8,7,6,5,4,3,2,1,0



Swap_Waveforms:
	lda	<waveformno
	tay			;save for later comparison
	inc	a
	cmp	#50		;limit
	bne	.no_reset
	cla
.no_reset:
	sta	<waveformno
	tax
	lda	Wave_Mirror_Table,X
	cmp	Wave_Mirror_Table,Y
	bne	.different_waves
	rts			;leave early if wave data same.
.different_waves:
	sta	<_si
	stz	<_si+1
	aslw    <_si
 	aslw    <_si
	aslw    <_si
	aslw    <_si
	aslw    <_si		;x32
	addw    #LowPassWaves,<_si
	stw	<_si,(RAMTIN+(TIN_INSTR-TIN_START)+1)
	stw	<_si,(RAMTIN+(TIN_OLD_INSTR-TIN_START)+1)
	bbs0	<Snd_Method,.old_method	
	jmp	RAMTIN
.old_method:
	jmp	RAMTIN+(TIN_OLD_START-TIN_START)
	rts

TIN_START:
	stz	$0800
	ldy     #DEF_COPY_FREQ
	lda	#$DF
	ldx	#$9F
	stz	$0803
	sty	$0802
	sta	$0804
	stx	$0804
TIN_INSTR:
	TIN wave_saw,$0806,32
	stw	<Ch0_Freq,$0802		;Write default frequency
	rts
TIN_END:

TIN_OLD_START:
	stz	$0800
	lda	#$5F
	ldx	#$1F
	ldy	#$9F
	sta	$0804
	stx	$0804
TIN_OLD_INSTR:
	TIN wave_saw,$0806,32
	sty	$0804
	rts
TIN_OLD_END:


;The "NEW" way?
;	stz	$0800
;	ldy     #DEF_COPY_FREQ
;	lda	#$DF
;	ldx	#$9F
;	stz	$0803
;	sty	$0802
;	sta	$0804
;	stx	$0804
;TIN_INSTR:
;	TIN wave_saw,$0806,32
;	stw	#DEF_FREQ,$0802		;Write default frequency
;	rts


;The Traditional Way
;	stz	$0800
;	lda	#$5F
;	ldx	#$1F
;	ldy	#$9F
;	sta	$0804
;	stx	$0804
;TIN_OLD_INSTR:
;	TIN wave_saw,$0806,32
;	sty	$0804
;	rts