; Sound.asm: program to play around with the sound HW.
;
;
;

        .include "INC\My_startup.asm"
	.nomlist
	.list
; ----
Sc1_CHR_VRAM	= $2000
Sc2_CHR_VRAM	= $5000
DEF_FREQ	= $0400
DEF_COPY_FREQ	= $0003
RAMTIN		= $3F00

; Zero-page variables

	.zp

nmi_count: ds	1	;Counter for NMIs...
VCE_copy:  ds	1
six_button: ds  1
Copy_Freq: ds 1		;Default countdown timer
Copy_Ctr:  ds 1		;current counter
Ch0_Freq: ds 2		;a frequency variable
waveformno: ds 1
Sweep_On: ds 1		;do we sweep?
Vibrato_Idx: ds 1
Snd_Method: ds 1	;new/old way?
Charset: ds 1		;Upper/Lower 128 ASCII?



	.bss
satb		.ds 512	; the local SATB
	;...

;--- CODE area ----------

	.code
	.bank START_BANK

main:
	lda	#8		;default copying speed
	sta	<Copy_Freq
	sta	<Copy_Ctr
	stz	<waveformno
	stw	#DEF_FREQ,<Ch0_Freq
	stz	<Vibrato_Idx
	stz	<Snd_Method

	TII	TIN_START,RAMTIN,$0080

	lda	#0
	sta	<Sweep_On

	jsr	setup_sound

	jsr	setup_video

	setvec #VSYNC,vsync_proc
	vec_on #VSYNC
	vec_off #HSYNC

	SCREEN_ON

.here:	bra    .here

	;...

Vibrato_Tbl:;,1,2,3,4,5,6,7,8,9,a,b,c,d,e,f
	.db 0,1,2,3,4,5,6,7,7,6,5,4,3,2,1,0

vsync_proc:
	inc	<nmi_count
	jsr	TestJoypad	;This changes the values and cursor
	jsr	UpdateScreen


	stz	$0800		;point to ch.0
;	lda	<Vibrato_Idx
;	inc	a
;	and	#$f
;	sta	<Vibrato_Idx
;	tax
;	lda	Vibrato_Tbl,X

	cla
	clc
	adc	<Ch0_Freq
	sta	$0802
	lda     <Ch0_Freq+1
	adc	#0
	sta	$0803
	bbr0	<Sweep_On,.no_sweep
	incw    <Ch0_Freq
	lda	<Ch0_Freq+1	;get high byte
	and	#$07
	sta     <Ch0_Freq+1
.no_sweep:


	lda	<Copy_Ctr
	dec	a
	bne	.no_swap_sounds
	jsr	Swap_Waveforms
	lda	<Copy_Freq	;reload the copying rate
.no_swap_sounds:
	sta	<Copy_Ctr


;	st0	#8	;Vertical scroll
;	lda	#8
;	stz	video_data
;	stz	video_data+1
	rts

;[ USER DATA ]



;==============================================================================
TestJoypad:
	stz	<six_button

	tst	#$40,joy	;This is UP?
	beq	.NoPushUp
	lda	<Ch0_Freq
	add	#2
	sta	<Ch0_Freq
	cla
	adc	<Ch0_Freq+1
	and	#$F
	sta	<Ch0_Freq+1
.NoPushUp
	tst	#$10,joy	;This is DOWN?
	beq	.NoPushDn
	lda	<Ch0_Freq
	sub	#2
	sta	<Ch0_Freq
	lda	<Ch0_Freq+1
	sbc	#0
	and	#$F
	sta	<Ch0_Freq+1
.NoPushDn
	tst	#$20,joytrg	;This is RIGHT
	beq	.NoPushRight
	inc	<Copy_Freq
	lda	<Copy_Freq
	sta	<Copy_Ctr
.NoPushRight
	tst	#$80,joytrg	;This is LEFT
	beq	.NoPushLeft
	dec	<Copy_Freq
	lda	<Copy_Freq
	sta	<Copy_Ctr
.NoPushLeft
	tst	#$01,joytrg	;This is I
	beq	.NoPushButI
	lda	<Sweep_On
	eor	#1
	sta	<Sweep_On
.NoPushButI:
	tst	#$02,joytrg	;This is II
	beq	.NoPushButII
	lda	<Snd_Method
	eor	#1
	sta	<Snd_Method
	bne	.to_old
	stw	#NEWTXT,<_si
	bra	.meth_prt
.to_old:
	stw	#OLDTXT,<_si
.meth_prt:
	stw	#$00FB,<_di	;Get editor position
	jsr	print_text
.NoPushButII:


	rts

;=======================================================================

;***************************************************


setup_video:
	SCREEN_OFF
	init_satb satb
	jsr	Update_Satb_BLOCKTRANSFER
	jsr	xres_256
	jsr	yres_224
	jsr	BAT_3264

	jsr	clear_VRAM
	stw	#Intro_Text,<_si ;Point to my text
	stw	#$0020,<_di	 ;Point to screen
	jsr	print_text

	map	MYGFX
	set_bgpal #0,MYPAL,#2	; fill palette #0,1
        vload	MYGFX,#$1800


	st0	#8	;Clear scrolling?
	stwz	video_data
	st0	#7	;Clear scrolling?
	stwz	video_data
	rts

;*******************************************************************************
clear_VRAM:		;Clears xxxx words of VRAM.
	setvwaddr  $0		; set the VRAM address to $0000
	stw	#$1000,<_si
.clear_vram0:
	st1	#$20
	st2	#$01
	decw	<_si
	bcs	.clear_vram0
	rts

UpdateScreen:
	stw	#$009B,<_di	;Get editor position
	jsr	set_write
	lda     <Copy_Freq
	jsr	print_byte	;Write BYTES
	st1	#$20
	st2	#$01
	lda     <Copy_Freq+1
	jsr	print_byte	;Write BYTES

	stw	#$00BB,<_di	;Get editor position
	jsr	set_write
	lda     <Ch0_Freq+1
	jsr	print_byte	;Write BYTES
	lda     <Ch0_Freq
	jsr	print_byte	;Write BYTES

	rts





print_byte:	;Prints a byte to the screen.
	pha			; preserve
	lsr   a 		; use top nybble
	lsr   a
	lsr   a
	lsr   a
	add   #$10
	sta   video_data	; store char # (0-F) (LSB of VRAM word)
	lda   #$01
	sta   video_data+1
.nextprintbyte
	pla			; restore byte
	and   #$0F		; use bottom nybble
	add   #$10
	sta   video_data	; store char # (0-F) (LSB of VRAM word)
	lda   #$01
	sta   video_data+1
	rts

print_text:
	jsr	set_write
	lda	#$80
	sta	<Charset	;default each time
	cly
	ldx	#1		;Palette 0, $1000 VRAM
.loop1
	lda	[_si],Y
	beq	.finish
	bpl	.no_swap_charset
	;swap character set if encountering -ve char!
	lda     <Charset
	eor	#$80
	sta	<Charset
	bra     .skip_write
.no_swap_charset:
	ora	<Charset
	sta	video_data
	stx	video_data+1
.skip_write:
	incw	<_si
	bra	.loop1
.finish
	rts

Intro_Text:
     ;0123456789ABCDEF0123456789ABCDEF
 .db " WAVE WRITING TOOL <OLD / NEW>  "
 .db " CHRIS COVELL 1/22/2017         "
 .db "                                "
 .db " L/R FOR WAVE CHANGE SPEED      "
 .db " U/D FOR FREQUENCY              "
 .db " I   TO TURN ON/OFF SWEEP       "
 .db " II  TO SWAP WAVE METHOD   NEW  ",$ff
 .db "                                "
 .db "                                "
 .db "                                "
 .db " --NEW--          --OLD--       "
 .db "STZ $0800        STZ $0800      "
 .db "LDY #$03         LDA #$5F       "
 .db "LDA #$DF         LDX #$1F       "
 .db "LDX #$9F         LDY #$9F       "
 .db "STZ $0803        STA $0804      "
 .db "STY $0802        STX $0804      "
 .db "STA $0804        TIN wf,$0806,32"
 .db "STX $0804        STY $0804      "
 .db "TIN wf,$0806,32                 "
 .db "STW <freq,$0802                 "
 .db 0

NEWTXT: .db "NEW",0
OLDTXT: .db "OLD",0
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

BAT_3264:			;Set virtual width to 32, height to 64
	st0	#9
	st1	#%01000000
	st2	#0
	rts

yres_224:
	st0 #$0C
	stw #$1702,video_data
	st0 #$0D
	stw #$00DF,video_data
	rts

yres_240:
	st0	#$0C
	st1     #$02
	st2	#$0D
	st0	#$0D
	st1	#$EF
	st2	#$00
	rts

xres_256:
	st0	#$0A
	st1	#$02
	st2	#$02
	st0	#$0B
	st1	#$1F
	st2	#$04
	lda	#%00000100	;or #%00000000 for chroma fix OFF
	sta	$0400
	sta	<VCE_copy
	rts

Update_Satb_BLOCKTRANSFER:
	stw   #$7F00,<_di	;Default SATB location
	jsr	set_write	;Load up into latch
	tia   satb,$0002,$0200	;BLOCK TRANSFER INSTRUCTION!
				;Block transfer 512 bytes...
				;from RAM to VRAM thru $0002!
			;MUCH more efficient than the MagicKit code!
	st0	#$13	;Sprite transfer DMA
	stw	#$7F00,$0002	;Copy the SATB __ONCE!!__
	rts

MYPAL:
	.incpal "GFX\GunstarASCII.pcx",0,2


	.include "INC\sound.asm"
;**************************************************
	.bank	MAIN_BANK
	.org	$4000
MYGFX:	.vram	$1000
	.incchr "GFX\GunstarASCII.pcx"
